/*Processing接受到Arduino控制器的红外热释传感器发出的
触发信号后，画布上的路灯点亮，当人走过画布后，画布黑屏*/
import processing.serial.*;//导入serial通信库
Serial duankou;//创建对象duankou
//变量存储Arduino传来数据，用来标志传感器是否被触发
int data;
int frame=0;//动画变量
int flag=0;//路灯是否亮标志
//声明一个PImage类型
PImage photo1;//人偶图片定义
PImage photo2;//路灯图片定义
//串行通讯子程序
void communication()
{
  if(duankou.available()>0)
  {
    //把Arduino传来的字节存入变量data
    //一个字节数值范围是0~255.
    data=duankou.read();
    //把Arduino传来的字节显示在控制台中
    println(data);  
    //如果data=1，则说明红外热释被触发
    if(data==1)
    {
      flag=1;//路灯亮标志
    }    
  }
}
//初始化程序
void setup()
{
  size(700,400);//画布尺寸定义
  //调用图片到变量photo
  photo1=loadImage("Puppet.JPG");
  photo2=loadImage("light_bulb.png");
   //设定通讯端口为COM3，波特率为9600
  duankou = new Serial(this,"COM3",9600);
}
//主程序
void draw()
{
  communication();//调用通讯程序
  if(flag==1 && frame<=680)//如果路灯亮
  {
       background(255);
       image(photo2,200,-10);//设置路灯在画布的位置
       for(int i=0;i<50;i++)//延时
       { communication();//调用通讯程序
        }
       image(photo1,frame,235);//人偶沿X坐标         
       frame+=1;//增加动画变量值    
     }
    else
   {
     background(0);//画布黑屏
    flag=0;//flag设置为路灯不亮标志
    frame=0;//动画变量清零
    communication();//调用通讯程序
   }
}

